<div id="data-grid-demo">
<dx-data-grid
id="gridContainer"
keyExpr="ID"
[dataSource]="dataSource"
[showBorders]="true"
(onEditorPreparing)="onEditorPreparing($event)"
>
<dxo-data-grid-editing
mode="row"
[allowUpdating]="true"
[allowAdding]="true"
>
</dxo-data-grid-editing>
<dxi-data-grid-column dataField="FirstName"></dxi-data-grid-column>
<dxi-data-grid-column dataField="LastName"></dxi-data-grid-column>
<dxi-data-grid-column dataField="Position"></dxi-data-grid-column>
<dxi-data-grid-column
dataField="StateID"
caption="State"
[setCellValue]="setStateValue"
>
<dxo-data-grid-lookup
[dataSource]="states"
valueExpr="ID"
displayExpr="Name"
>
</dxo-data-grid-lookup>
</dxi-data-grid-column>
<dxi-data-grid-column dataField="CityID" caption="City">
<dxo-data-grid-lookup
[dataSource]="getFilteredCities"
valueExpr="ID"
displayExpr="Name"
>
</dxo-data-grid-lookup>
</dxi-data-grid-column>
</dx-data-grid>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxDataGridModule, DxDataGridTypes } from 'devextreme-angular/ui/data-grid';
import {
Service, Employee, State, City,
} from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
styleUrls: [`app/app.component.css`],
selector: 'demo-app',
templateUrl: `app/app.component.html`,
providers: [Service],
imports: [
DxDataGridModule,
],
})
export class AppComponent {
dataSource: Employee[];
states: State[];
cities: City[];
constructor(private service: Service) {
this.dataSource = service.getEmployees();
this.states = service.getStates();
this.cities = service.getCities();
this.getFilteredCities = this.getFilteredCities.bind(this);
}
getFilteredCities(options: { data: City }) {
return {
store: this.cities,
filter: options.data ? ['StateID', '=', options.data.StateID] : null,
};
}
onEditorPreparing(e: DxDataGridTypes.EditorPreparingEvent<Employee>) {
if (e.parentType === 'dataRow' && e.dataField === 'CityID') {
e.editorOptions.disabled = e.row.data.StateID === undefined;
}
}
setStateValue(this: DxDataGridTypes.Column, newData: Employee, value: number, currentRowData: Employee) {
newData.CityID = null;
this.defaultSetCellValue?.(newData, value, currentRowData);
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
import { Injectable } from '@angular/core';
export class Employee {
ID: number;
FirstName: string;
LastName: string;
Prefix: string;
Position: string;
StateID: number;
CityID: number;
}
export class State {
ID: number;
Name: string;
}
export class City {
ID: number;
Name: string;
StateID: number;
}
const employees: Employee[] = [{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Prefix: 'Mr.',
Position: 'CTO',
StateID: 5,
CityID: 17,
}, {
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Prefix: 'Mrs.',
Position: 'HR Manager',
StateID: 5,
CityID: 17,
}, {
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Prefix: 'Mr.',
Position: 'IT Manager',
StateID: 4,
CityID: 14,
}, {
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Prefix: 'Ms.',
Position: 'Shipping Manager',
StateID: 3,
CityID: 8,
}, {
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Prefix: 'Mr.',
Position: 'Shipping Manager',
StateID: 3,
CityID: 9,
}, {
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Network Admin',
StateID: 2,
CityID: 6,
}, {
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Network Admin',
StateID: 1,
CityID: 3,
}, {
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'Sales Assistant',
StateID: 1,
CityID: 3,
}, {
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Sales Assistant',
StateID: 1,
CityID: 2,
}, {
ID: 10,
FirstName: 'Taylor',
LastName: 'Riley',
Prefix: 'Mr.',
Position: 'Support Assistant',
StateID: 5,
CityID: 17,
}, {
ID: 11,
FirstName: 'Sam',
LastName: 'Hill',
Prefix: 'Mr.',
Position: 'Sales Assistant',
StateID: 2,
CityID: 5,
}, {
ID: 12,
FirstName: 'Kelly',
LastName: 'Rodriguez',
Prefix: 'Ms.',
Position: 'Sales Assistant',
StateID: 5,
CityID: 17,
}, {
ID: 13,
FirstName: 'Natalie',
LastName: 'Maguirre',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
StateID: 4,
CityID: 14,
}, {
ID: 14,
FirstName: 'Walter',
LastName: 'Hobbs',
Prefix: 'Mr.',
Position: 'Support Assistant',
StateID: 2,
CityID: 5,
}];
const states: State[] = [{
ID: 1,
Name: 'Alabama',
}, {
ID: 2,
Name: 'Alaska',
}, {
ID: 3,
Name: 'Arizona',
}, {
ID: 4,
Name: 'Arkansas',
}, {
ID: 5,
Name: 'California',
}];
const cities: City[] = [{
ID: 1,
Name: 'Tuscaloosa',
StateID: 1,
}, {
ID: 2,
Name: 'Hoover',
StateID: 1,
}, {
ID: 3,
Name: 'Dothan',
StateID: 1,
}, {
ID: 4,
Name: 'Decatur',
StateID: 1,
}, {
ID: 5,
Name: 'Anchorage',
StateID: 2,
}, {
ID: 6,
Name: 'Fairbanks',
StateID: 2,
}, {
ID: 7,
Name: 'Juneau',
StateID: 2,
}, {
ID: 8,
Name: 'Avondale',
StateID: 3,
}, {
ID: 9,
Name: 'Buckeye',
StateID: 3,
}, {
ID: 10,
Name: 'Carefree',
StateID: 3,
}, {
ID: 11,
Name: 'Springdale',
StateID: 4,
}, {
ID: 12,
Name: 'Rogers',
StateID: 4,
}, {
ID: 13,
Name: 'Sherwood',
StateID: 4,
}, {
ID: 14,
Name: 'Jacksonville',
StateID: 4,
}, {
ID: 15,
Name: 'Cabot',
StateID: 4,
}, {
ID: 16,
Name: 'Adelanto',
StateID: 5,
}, {
ID: 17,
Name: 'Glendale',
StateID: 5,
}, {
ID: 18,
Name: 'Moorpark',
StateID: 5,
}, {
ID: 19,
Name: 'Needles',
StateID: 5,
}, {
ID: 20,
Name: 'Ontario',
StateID: 5,
}];
@Injectable()
export class Service {
getEmployees() {
return employees;
}
getStates() {
return states;
}
getCities() {
return cities;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.7/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.24/package.json',
'npm:devexpress-gantt@4.1.64/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.0.5"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

<template>
<div id="data-grid-demo">
<DxDataGrid
:data-source="employees"
:show-borders="true"
key-expr="ID"
@editor-preparing="onEditorPreparing"
>
<DxEditing
:allow-updating="true"
:allow-adding="true"
mode="row"
/>
<DxColumn
data-field="FirstName"
/>
<DxColumn
data-field="LastName"
/>
<DxColumn
data-field="Position"
/>
<DxColumn
:set-cell-value="setStateValue"
data-field="StateID"
caption="State"
>
<DxLookup
:data-source="states"
display-expr="Name"
value-expr="ID"
/>
</DxColumn>
<DxColumn
data-field="CityID"
caption="City"
>
<DxLookup
:data-source="getFilteredCities"
display-expr="Name"
value-expr="ID"
/>
</DxColumn>
</DxDataGrid>
</div>
</template>
<script setup lang="ts">
import {
DxDataGrid, DxColumn, DxEditing, DxLookup, type DxDataGridTypes,
} from 'devextreme-vue/data-grid';
import {
employees, states, cities, type Employee, type City,
} from './data.ts';
function setStateValue(
this: DxDataGridTypes.Column, newData: Employee, value: number, currentRowData: Employee,
) {
newData.CityID = null;
this.defaultSetCellValue?.(newData, value, currentRowData);
}
const getFilteredCities = (options: { data: City }) => ({
store: cities,
filter: options.data ? ['StateID', '=', options.data.StateID] : null,
});
const onEditorPreparing = (e: DxDataGridTypes.EditorPreparingEvent<Employee>) => {
if (e.parentType === 'dataRow' && e.dataField === 'CityID') {
const isStateNotSet = e.row!.data.StateID === undefined;
e.editorOptions.disabled = isStateNotSet;
}
};
</script>
<style>
#data-grid-demo {
min-height: 700px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
export type Employee = {
ID: number;
FirstName: string;
LastName: string;
Prefix: string;
Position: string;
StateID: number;
CityID: number | null;
};
export type State = {
ID: number;
Name: string;
};
export type City = {
ID: number;
Name: string;
StateID: number;
};
export const employees: Employee[] = [{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Prefix: 'Mr.',
Position: 'CTO',
StateID: 5,
CityID: 17,
}, {
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Prefix: 'Mrs.',
Position: 'HR Manager',
StateID: 5,
CityID: 17,
}, {
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Prefix: 'Mr.',
Position: 'IT Manager',
StateID: 4,
CityID: 14,
}, {
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Prefix: 'Ms.',
Position: 'Shipping Manager',
StateID: 3,
CityID: 8,
}, {
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Prefix: 'Mr.',
Position: 'Shipping Manager',
StateID: 3,
CityID: 9,
}, {
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Network Admin',
StateID: 2,
CityID: 6,
}, {
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Network Admin',
StateID: 1,
CityID: 3,
}, {
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'Sales Assistant',
StateID: 1,
CityID: 3,
}, {
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Sales Assistant',
StateID: 1,
CityID: 2,
}, {
ID: 10,
FirstName: 'Taylor',
LastName: 'Riley',
Prefix: 'Mr.',
Position: 'Support Assistant',
StateID: 5,
CityID: 17,
}, {
ID: 11,
FirstName: 'Sam',
LastName: 'Hill',
Prefix: 'Mr.',
Position: 'Sales Assistant',
StateID: 2,
CityID: 5,
}, {
ID: 12,
FirstName: 'Kelly',
LastName: 'Rodriguez',
Prefix: 'Ms.',
Position: 'Sales Assistant',
StateID: 5,
CityID: 17,
}, {
ID: 13,
FirstName: 'Natalie',
LastName: 'Maguirre',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
StateID: 4,
CityID: 14,
}, {
ID: 14,
FirstName: 'Walter',
LastName: 'Hobbs',
Prefix: 'Mr.',
Position: 'Support Assistant',
StateID: 2,
CityID: 5,
}];
export const states: State[] = [{
ID: 1,
Name: 'Alabama',
}, {
ID: 2,
Name: 'Alaska',
}, {
ID: 3,
Name: 'Arizona',
}, {
ID: 4,
Name: 'Arkansas',
}, {
ID: 5,
Name: 'California',
}];
export const cities: City[] = [{
ID: 1,
Name: 'Tuscaloosa',
StateID: 1,
}, {
ID: 2,
Name: 'Hoover',
StateID: 1,
}, {
ID: 3,
Name: 'Dothan',
StateID: 1,
}, {
ID: 4,
Name: 'Decatur',
StateID: 1,
}, {
ID: 5,
Name: 'Anchorage',
StateID: 2,
}, {
ID: 6,
Name: 'Fairbanks',
StateID: 2,
}, {
ID: 7,
Name: 'Juneau',
StateID: 2,
}, {
ID: 8,
Name: 'Avondale',
StateID: 3,
}, {
ID: 9,
Name: 'Buckeye',
StateID: 3,
}, {
ID: 10,
Name: 'Carefree',
StateID: 3,
}, {
ID: 11,
Name: 'Springdale',
StateID: 4,
}, {
ID: 12,
Name: 'Rogers',
StateID: 4,
}, {
ID: 13,
Name: 'Sherwood',
StateID: 4,
}, {
ID: 14,
Name: 'Jacksonville',
StateID: 4,
}, {
ID: 15,
Name: 'Cabot',
StateID: 4,
}, {
ID: 16,
Name: 'Adelanto',
StateID: 5,
}, {
ID: 17,
Name: 'Glendale',
StateID: 5,
}, {
ID: 18,
Name: 'Moorpark',
StateID: 5,
}, {
ID: 19,
Name: 'Needles',
StateID: 5,
}, {
ID: 20,
Name: 'Ontario',
StateID: 5,
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.7/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/typescript@5.4.5/lib/typescript.js"></script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

import React from 'react';
import DataGrid, { Column, Editing, Lookup } from 'devextreme-react/data-grid';
import service from './data.js';
class App extends React.Component {
constructor(props) {
super(props);
this.dataSource = service.getEmployees();
this.states = service.getStates();
this.cities = service.getCities();
this.getFilteredCities = this.getFilteredCities.bind(this);
}
getFilteredCities(options) {
return {
store: this.cities,
filter: options.data ? ['StateID', '=', options.data.StateID] : null
};
}
onEditorPreparing(e) {
if (e.parentType === 'dataRow' && e.dataField === 'CityID') {
e.editorOptions.disabled = (typeof e.row.data.StateID !== 'number');
}
}
setStateValue(rowData, value) {
rowData.CityID = null;
this.defaultSetCellValue(rowData, value);
}
render() {
return (
<div id="data-grid-demo">
<DataGrid
dataSource={this.dataSource}
keyExpr="ID"
showBorders={true}
onEditorPreparing={this.onEditorPreparing}
>
<Editing
mode="row"
allowUpdating={true}
allowAdding={true}>
</Editing>
<Column dataField="FirstName" />
<Column dataField="LastName" />
<Column dataField="Position" />
<Column dataField="StateID" caption="State" setCellValue={this.setStateValue}>
<Lookup dataSource={this.states} displayExpr="Name" valueExpr="ID" />
</Column>
<Column dataField="CityID" caption="City">
<Lookup dataSource={this.getFilteredCities} displayExpr="Name" valueExpr="ID" />
</Column>
</DataGrid>
</div>
);
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app')
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#data-grid-demo {
min-height: 700px;
}
const employees = [{
'ID': 1,
'FirstName': 'John',
'LastName': 'Heart',
'Prefix': 'Mr.',
'Position': 'CTO',
'StateID': 5,
'CityID': 17
}, {
'ID': 2,
'FirstName': 'Olivia',
'LastName': 'Peyton',
'Prefix': 'Mrs.',
'Position': 'HR Manager',
'StateID': 5,
'CityID': 17
}, {
'ID': 3,
'FirstName': 'Robert',
'LastName': 'Reagan',
'Prefix': 'Mr.',
'Position': 'IT Manager',
'StateID': 4,
'CityID': 14
}, {
'ID': 4,
'FirstName': 'Greta',
'LastName': 'Sims',
'Prefix': 'Ms.',
'Position': 'Shipping Manager',
'StateID': 3,
'CityID': 8
}, {
'ID': 5,
'FirstName': 'Brett',
'LastName': 'Wade',
'Prefix': 'Mr.',
'Position': 'Shipping Manager',
'StateID': 3,
'CityID': 9
}, {
'ID': 6,
'FirstName': 'Sandra',
'LastName': 'Johnson',
'Prefix': 'Mrs.',
'Position': 'Network Admin',
'StateID': 2,
'CityID': 6
}, {
'ID': 7,
'FirstName': 'Kevin',
'LastName': 'Carter',
'Prefix': 'Mr.',
'Position': 'Network Admin',
'StateID': 1,
'CityID': 3
}, {
'ID': 8,
'FirstName': 'Cynthia',
'LastName': 'Stanwick',
'Prefix': 'Ms.',
'Position': 'Sales Assistant',
'StateID': 1,
'CityID': 3
}, {
'ID': 9,
'FirstName': 'Kent',
'LastName': 'Samuelson',
'Prefix': 'Dr.',
'Position': 'Sales Assistant',
'StateID': 1,
'CityID': 2
}, {
'ID': 10,
'FirstName': 'Taylor',
'LastName': 'Riley',
'Prefix': 'Mr.',
'Position': 'Support Assistant',
'StateID': 5,
'CityID': 17
}, {
'ID': 11,
'FirstName': 'Sam',
'LastName': 'Hill',
'Prefix': 'Mr.',
'Position': 'Sales Assistant',
'StateID': 2,
'CityID': 5
}, {
'ID': 12,
'FirstName': 'Kelly',
'LastName': 'Rodriguez',
'Prefix': 'Ms.',
'Position': 'Sales Assistant',
'StateID': 5,
'CityID': 17
}, {
'ID': 13,
'FirstName': 'Natalie',
'LastName': 'Maguirre',
'Prefix': 'Mrs.',
'Position': 'Sales Assistant',
'StateID': 4,
'CityID': 14
}, {
'ID': 14,
'FirstName': 'Walter',
'LastName': 'Hobbs',
'Prefix': 'Mr.',
'Position': 'Support Assistant',
'StateID': 2,
'CityID': 5
}];
const states = [{
'ID': 1,
'Name': 'Alabama'
}, {
'ID': 2,
'Name': 'Alaska'
}, {
'ID': 3,
'Name': 'Arizona'
}, {
'ID': 4,
'Name': 'Arkansas'
}, {
'ID': 5,
'Name': 'California'
}];
const cities = [{
'ID': 1,
'Name': 'Tuscaloosa',
'StateID': 1
}, {
'ID': 2,
'Name': 'Hoover',
'StateID': 1
}, {
'ID': 3,
'Name': 'Dothan',
'StateID': 1
}, {
'ID': 4,
'Name': 'Decatur',
'StateID': 1
}, {
'ID': 5,
'Name': 'Anchorage',
'StateID': 2
}, {
'ID': 6,
'Name': 'Fairbanks',
'StateID': 2
}, {
'ID': 7,
'Name': 'Juneau',
'StateID': 2
}, {
'ID': 8,
'Name': 'Avondale',
'StateID': 3
}, {
'ID': 9,
'Name': 'Buckeye',
'StateID': 3
}, {
'ID': 10,
'Name': 'Carefree',
'StateID': 3
}, {
'ID': 11,
'Name': 'Springdale',
'StateID': 4
}, {
'ID': 12,
'Name': 'Rogers',
'StateID': 4
}, {
'ID': 13,
'Name': 'Sherwood',
'StateID': 4
}, {
'ID': 14,
'Name': 'Jacksonville',
'StateID': 4
}, {
'ID': 15,
'Name': 'Cabot',
'StateID': 4
}, {
'ID': 16,
'Name': 'Adelanto',
'StateID': 5
}, {
'ID': 17,
'Name': 'Glendale',
'StateID': 5
}, {
'ID': 18,
'Name': 'Moorpark',
'StateID': 5
}, {
'ID': 19,
'Name': 'Needles',
'StateID': 5
}, {
'ID': 20,
'Name': 'Ontario',
'StateID': 5
}];
export default {
getEmployees() {
return employees;
},
getStates() {
return states;
},
getCities() {
return cities;
}
};
System.config({
transpiler: 'plugin-babel',
meta: {
},
paths: {
'npm:': 'https://unpkg.com/'
},
defaultExtension: 'js',
map: {
'react': 'npm:react@16.14.0/umd/react.development.js',
'react-dom': 'npm:react-dom@16.14.0/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.7.2/prop-types.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.25.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.4',
'devextreme-react': 'npm:devextreme-react@20.2.4',
'jszip': 'npm:jszip@3.5.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.9.7/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.5/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.8/dist/dx-gantt.js',
'preact': 'npm:preact@10.5.7/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.7/hooks/dist/hooks.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js'
},
packages: {
'devextreme': {
defaultExtension: 'js'
},
'devextreme-react': {
main: 'index.js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true,
react: true
}
});